unit HlavniU;
{.$DEFINE debug}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, AppEvnts;

type
	EXMLParseException=class(Exception);

  TMesto=record
  	Nazev:string;
    XPos,YPos:Integer;
  end;

  TCesta=record
  	ZMesta:string;
    ZMestaI:integer;
    DoMesta:string;
    DoMestaI:integer;
    Vzdalenost:integer;
    PrumRychl:real;
    Hledano:boolean;
  end;

  TSpotreba=record
  	Rychlost:integer;
    Litru:real;
  end;

  TMesta=array of TMesto;
  TCesty=array of TCesta;
  TSpotreby=array of TSpotreba;
    
  TformHlavni = class(TForm)
    mmnuHlavni: TMainMenu;
    odlgXML: TOpenDialog;
    mnuiProgram: TMenuItem;
    mnuiNacistMapu: TMenuItem;
    mnuiSeparator1: TMenuItem;
    mnuiKonec: TMenuItem;
    mnuiDebugLoad: TMenuItem;
    sboxMapa: TScrollBox;
    panlInfo: TPanel;
    spliMapaInfo: TSplitter;
    pboxMapa: TPaintBox;
    cboxZvetseni: TComboBox;
    chbxPopisky: TCheckBox;
    lablZvetseni: TLabel;
    chbxCesty: TCheckBox;
    cboxOkolni: TComboBox;
    lablVyberMesto: TLabel;
    butnOkolni: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label1: TLabel;
    cboxKonec: TComboBox;
    butnCesta: TButton;
    Label2: TLabel;
    mnuiNapoveda: TMenuItem;
    mnuiNpoveda1: TMenuItem;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuiKonecClick(Sender: TObject);
    procedure mnuiNacistMapuClick(Sender: TObject);
    procedure mnuiDebugLoadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure pboxMapaPaint(Sender: TObject);
    procedure cboxZvetseniChange(Sender: TObject);
    procedure chbxPopiskyClick(Sender: TObject);
    procedure chbxCestyClick(Sender: TObject);
    procedure cboxOkolniChange(Sender: TObject);
    procedure butnOkolniClick(Sender: TObject);
    procedure butnCestaClick(Sender: TObject);
    procedure mnuiNpoveda1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure NactiMapu(jmeno:string);
    procedure KresliMapu;
    procedure DejMestaDoComba(combo:TComboBox);
  end;

var
  formHlavni: TformHlavni;

  Mesta:TMesta=nil;
  Cesty:TCesty=nil;
  Spotreby:TSpotreby=nil;
  MestaPocet:integer=0;
  CestyPocet:integer=0;
  SpotrebyPocet:integer=0;
  Zvetseni:integer=1;
  Popisky:Boolean=false;
  KresliCesty:Boolean=true;

implementation

uses Math, OkoliU, NapovedaU;

{$R *.dfm}

function DejVybrane(cbox:TComboBox):integer;
  begin;
  	if cbox.Items.Count=0 then
    	Result:=-1
    else
	  	Result:=integer(cbox.Items.Objects[cbox.ItemIndex]);
  end;

procedure TformHlavni.DejMestaDoComba(combo:TComboBox);
var
	i:integer;
begin
	combo.Items.Clear;
	for i:=0 to MestaPocet-1 do
  	combo.Items.AddObject(Mesta[i].Nazev,TObject(i));
  combo.Sorted:=true;
  combo.ItemIndex:=0;
end;


function NajdiMesto(jmeno:string):integer;
var
	i:integer;
begin
 	Result:=-1;
  for i:=0 to MestaPocet-1 do
  	if AnsiUpperCase(jmeno)=AnsiUpperCase(Mesta[i].Nazev) then begin
    	Result:=i;
      Exit;
    end;
end;

procedure TformHlavni.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
{$IFDEF debug}
	CanClose:=true;
{$Else}
	CanClose:=MessageBox(handle,'Opravdu ukonit program?','AutoAtlas',MB_ICONQUESTION+MB_YESNO)=idYes;
{$ENDIF}
end;

procedure TformHlavni.mnuiKonecClick(Sender: TObject);
begin
	Close;
end;

procedure TformHlavni.mnuiNacistMapuClick(Sender: TObject);
begin
	if odlgXML.Execute then begin
  	NactiMapu(odlgXML.FileName);
    KresliMapu;
  end;
end;

procedure TformHlavni.NactiMapu(jmeno:string);
var
	List:TStringList;
  List2:TStringList;
  Cnt:integer;

  procedure ZpracujRadek(xList:TStringList;s:string;LineNum:integer);
  var
  	Poz1,Poz2:integer;
  begin
  	Poz1:=Pos('<',S);
    Poz2:=Pos('>',S);
  	repeat
    	if Poz2<Poz1 then
	    	Raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'%s ;dek %d; (%s)',['Chybn ohranien tag',LineNum,S]);
      if ((Poz1=0)and(Poz2<>0))or((Poz1<>0)and(Poz2=0)) then
      	Raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'%s ;dek %d; (%s)',['Tag nen ukonen',LineNum,S]);
      if Poz1=1 then begin
      	xList.Add(Copy(S,1,Poz2));
        Delete(S,1,Poz2);
      end else begin
      	xList.Add(Copy(S,1,Poz1-1));
        xList.Add(Copy(S,Poz1,Poz2-Poz1+1));
        Delete(S,1,Poz2);
      end;
      Poz1:=Pos('<',S);
  	  Poz2:=Pos('>',S);
    until Poz1=0;
  end;

  function OdstranMezery(S:String):string;
  var
  	poz:integer;
  begin
  	poz:=Pos(' ',S);
  	while poz<>0 do begin
    	Delete(S,poz,1);
      poz:=Pos(' ',S);
    end;
    poz:=Pos(#9,S);
  	while poz<>0 do begin
    	Delete(S,poz,1);
      poz:=Pos(#9,S);
    end;
    Result:=S;
  end;

  procedure DejSekciDoListu(tag:string;Odkud,Kam:TStringList);
  var
  	Pridavat:boolean;
    Cnt:integer;
  begin
  	Kam.Clear;
	  Pridavat:=false;
	  for Cnt:=0 to Odkud.Count-1 do begin
	  	Odkud[Cnt]:=Trim(Odkud[Cnt]);
	  	if (Length(Odkud[Cnt])<>0) and (Odkud[Cnt][1]='<') then begin
	    	Odkud[Cnt]:=LowerCase(Odkud[Cnt]);
	      Odkud[Cnt]:=OdstranMezery(Odkud[Cnt]);
	    end;
	  	if Odkud[Cnt]='<'+tag+'>' then Pridavat:=true;
	    if Odkud[Cnt]='</'+tag+'>' then Pridavat:=false;
	    if Pridavat and (Odkud[Cnt]<>'<'+tag+'>') then Kam.Add(List2[Cnt]);
	  end;
  end;

  procedure OverSekci(tag:string;xList:TStringList;var xPocet:integer);
  var
  	CheckSum:integer;
    Cnt:Integer;
  begin
  	xPocet:=0;
    CheckSum:=0;
  	for Cnt:=0 to xList.Count-1 do begin
    	if xList[Cnt]='<'+tag+'>' then Inc(xPocet);
      if xList[Cnt]='</'+tag+'>' then Inc(CheckSum);
    end;
    if xPocet<>CheckSum then
	   	Raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'Nesouhlas poet tag <%s> a </%s>',[tag,tag]);
  end;

  procedure ZpracujMesta(xList:TStringList);
  var
  	Cnt:integer;
    Zpracuj:boolean;
    Radek:string;
    AktZprac:integer;
  begin
  	Zpracuj:=false;
  	
    AktZprac:=0;
  	OverSekci('mesto',xList,MestaPocet);
    SetLength(Mesta,MestaPocet);

    for Cnt:=0 to xList.Count-1 do begin
    	Radek:=xList[Cnt];
    	if Radek='<mesto>' then Zpracuj:=true;
      if Radek='</mesto>' then begin
      	Zpracuj:=false;
        Inc(AktZprac);
      end;
      if Zpracuj and (Radek<>'<mesto>') then begin
      	if Radek='<nazev>' then
        	Mesta[AktZprac].Nazev:=xList[Cnt+1];
        if Radek='<polohax>' then
        	Mesta[AktZprac].XPos:=StrToInt(xList[Cnt+1]);
        if Radek='<polohay>' then
        	Mesta[AktZprac].YPos:=StrToInt(xList[Cnt+1]);
      end;
    end;
  end;

  procedure ZpracujCesty(xList:TStringList);
  var
  	Cnt:integer;
    Zpracuj:boolean;
    Radek:string;
    AktZprac:integer;
  begin
  	Zpracuj:=false;
  	
    AktZprac:=0;
  	OverSekci('cesta',xList,CestyPocet);
    SetLength(Cesty,CestyPocet);

    for Cnt:=0 to xList.Count-1 do begin
    	Radek:=xList[Cnt];
    	if Radek='<cesta>' then Zpracuj:=true;
      if Radek='</cesta>' then begin
      	Zpracuj:=false;
        Inc(AktZprac);
      end;
      if Zpracuj and (Radek<>'<cesta>') then begin
      	if Radek='<z>' then
        	Cesty[AktZprac].ZMesta:=xList[Cnt+1];
        if Radek='<do>' then
        	Cesty[AktZprac].DoMesta:=xList[Cnt+1];
        if Radek='<vzdalenost>' then
        	Cesty[AktZprac].Vzdalenost:=StrToInt(xList[Cnt+1]);
        if Radek='<prumernarychlost>' then
        	Cesty[AktZprac].PrumRychl:=StrToFloat(xList[Cnt+1]);
      end;
    end;
  end;

  procedure ZpracujSpotreby(xList:TStringList);
  var
  	Cnt:integer;
    Zpracuj:boolean;
    Radek:string;
    S:string;
    AktZprac:integer;
    poz:integer;
  begin
  	Zpracuj:=false;
  	
    AktZprac:=0;
  	OverSekci('spotreba',xList,SpotrebyPocet);
    SetLength(Spotreby,SpotrebyPocet);

    for Cnt:=0 to xList.Count-1 do begin
    	Radek:=xList[Cnt];
    	if Radek='<spotreba>' then Zpracuj:=true;
      if Radek='</spotreba>' then begin
      	Zpracuj:=false;
        Inc(AktZprac);
      end;
      if Zpracuj and (Radek<>'<spotreba>') then begin
        if Radek='<rychlost>' then
        	Spotreby[AktZprac].Rychlost:=StrToInt(xList[Cnt+1]);
        if Radek='<litru>' then begin
        	for poz:=1 to Length(xList[Cnt+1]) do
          	if (xList[Cnt+1][poz]='.')or(xList[Cnt+1][poz]=',') then begin
            	S:=xList[Cnt+1];
              S[poz]:=DecimalSeparator;
              xList[Cnt+1]:=S;
            end;
        	Spotreby[AktZprac].Litru:=StrToFloat(xList[Cnt+1]);
        end;
      end;
    end;
  end;
  
begin
	Screen.Cursor:=crHourGlass;
  try
		List:=TStringList.Create;
	  List2:=TStringList.Create;
	  List.LoadFromFile(jmeno);
	  for Cnt:=0 to List.Count-1 do begin
	  	List[Cnt]:=Trim(List[Cnt]);
	    ZpracujRadek(List2,List[Cnt],Cnt);
	  end;
  
	  DejSekciDoListu('mesta',List2,List);
	  ZpracujMesta(List);

	  DejSekciDoListu('cesty',List2,List);
	  ZpracujCesty(List);

	  DejSekciDoListu('spotreby',List2,List);
	  ZpracujSpotreby(List);

	  for Cnt:=0 to CestyPocet-1 do begin
	  	Cesty[Cnt].ZMestaI:=NajdiMesto(Cesty[Cnt].ZMesta);
	    if Cesty[Cnt].ZMestaI=-1 then
		   	raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'Msto "%s" neexistuje',[Cesty[Cnt].ZMesta]);
	    Cesty[Cnt].DoMestaI:=NajdiMesto(Cesty[Cnt].DoMesta);
	    if Cesty[Cnt].DoMestaI=-1 then
		   	raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'Msto "%s" neexistuje',[Cesty[Cnt].DoMesta]);
	    if Cesty[Cnt].ZMestaI=Cesty[Cnt].DoMestaI then
	    	raise EXMLParseException.CreateFmt('Chyba pi parsovn souboru.'#13#10'Cesta vede do stejnho msta ("%s")',[Cesty[Cnt].DoMesta]);
	  end;

    DejMestaDoComba(cboxOkolni);
    DejMestaDoComba(cboxKonec);
    panlInfo.Visible:=true;
  finally
  	Screen.Cursor:=crDefault;
	  List.Free;
	  List2.Free;
  end;
end;

procedure TformHlavni.mnuiDebugLoadClick(Sender: TObject);
begin
	NactiMapu('mapa.xml');
  KresliMapu;
end;

procedure TformHlavni.FormCreate(Sender: TObject);
begin
{$IFDEF debug}
  mnuiDebugLoad.Visible:=true;
{$ENDIF}
	cboxZvetseni.ItemIndex:=0;
end;

procedure TformHlavni.KresliMapu;
var
	i:integer;
  RozsahX,RozsahY:integer;
  PosunX,PosunY:integer;

  function DejMaximumX:integer;
  var
  	i:integer;
  begin
  	Result:=-MaxInt;
  	for i:=0 to MestaPocet-1 do
    	if Mesta[i].XPos>Result then Result:=Mesta[i].XPos;
  end;

  function DejMaximumY:integer;
  var
  	i:integer;
  begin
  	Result:=-MaxInt;
  	for i:=0 to MestaPocet-1 do
    	if Mesta[i].YPos>Result then Result:=Mesta[i].YPos;
  end;

  function DejMinimumX:integer;
  var
  	i:integer;
  begin
  	Result:=MaxInt;
  	for i:=0 to MestaPocet-1 do
    	if Mesta[i].XPos<Result then Result:=Mesta[i].XPos;
  end;

  function DejMinimumY:integer;
  var
  	i:integer;
  begin
  	Result:=MaxInt;
  	for i:=0 to MestaPocet-1 do
    	if Mesta[i].YPos<Result then Result:=Mesta[i].YPos;
  end;

  function DejPoziciMestaX(mesto:integer):integer;
  begin
  	Result:=(Mesta[mesto].XPos+PosunX)*Zvetseni;
  end;

  function DejPoziciMestaY(mesto:integer):integer;
  begin
  	Result:=(Mesta[mesto].YPos+PosunY)*Zvetseni;
  end;

  
begin
	RozsahX:=DejMaximumX-DejMinimumX;
  RozsahY:=DejMaximumY-DejMinimumY;
  PosunX:=DejMinimumX;
  if PosunX<0 then
  	PosunX:=-PosunX
  else
  	PosunX:=0;
    
  PosunY:=DejMinimumY;
  if PosunY<0 then
  	PosunY:=-PosunY
  else
  	PosunY:=0;
  
  pboxMapa.Width:=(RozsahX+20)*Zvetseni;
  pboxMapa.Height:=(RozsahY+20)*Zvetseni;
  with pboxMapa.Canvas do begin
  	Brush.Color:=clGreen;
    FillRect(Rect(0,0,pboxMapa.Width,pboxMapa.Height));

    if KresliCesty then
	    for i:=0 to CestyPocet-1 do begin
    		Pen.Color:=clRed;
        Pen.Width:=Round(Cesty[i].PrumRychl/16.25);//koeficient pro max. rychlost v CR = 130 KM/H
        MoveTo(DejPoziciMestaX(Cesty[i].ZMestaI),DejPoziciMestaY(Cesty[i].ZMestaI));
        LineTo(DejPoziciMestaX(Cesty[i].DoMestaI),DejPoziciMestaY(Cesty[i].DoMestaI));
	    end;
      
    for i:=0 to MestaPocet-1 do begin
    	if DejVybrane(cboxOkolni)=i then
      	Brush.Color:=clAqua
      else if DejVybrane(cboxKonec)=i then
      	Brush.Color:=clLime
    	else
	    	Brush.Color:=clBlue;
	    Brush.Style:=bsSolid;
    	FillRect(Bounds(DejPoziciMestaX(i),DejPoziciMestaY(i),4*Zvetseni,4*Zvetseni));
      if Popisky then begin
	      Font:=pboxMapa.Font;
        if (DejVybrane(cboxOkolni)=i)or(DejVybrane(cboxKonec)=i) then
	      	Font.Color:=clBlue;
        Brush.Style:=bsClear;
  	    TextOut(DejPoziciMestaX(i),DejPoziciMestaY(i),Mesta[i].Nazev);
      end;
    end;
  end;
end;

procedure TformHlavni.pboxMapaPaint(Sender: TObject);
begin
	KresliMapu;
end;

procedure TformHlavni.cboxZvetseniChange(Sender: TObject);
begin
	Zvetseni:=cboxZvetseni.ItemIndex+1;
  pboxMapa.Repaint;
end;

procedure TformHlavni.chbxPopiskyClick(Sender: TObject);
begin
	Popisky:=chbxPopisky.Checked;
  pboxMapa.Repaint;
end;

procedure TformHlavni.chbxCestyClick(Sender: TObject);
begin
	KresliCesty:=chbxCesty.Checked;
  pboxMapa.Repaint;
end;

procedure TformHlavni.cboxOkolniChange(Sender: TObject);
begin
	pboxMapa.Repaint;
end;

procedure TformHlavni.butnOkolniClick(Sender: TObject);
begin
	if (cboxOkolni.Items.Count=0) or (cboxOkolni.ItemIndex=-1) then begin
  	MessageBox(handle,'Muste vybrat msto','AutoAtlas',MB_ICONWARNING);
  	exit;
  end;
  ZjistiOkoli(integer(cboxOkolni.Items.Objects[cboxOkolni.ItemIndex]));
end;

Type
	TTrasa=record
  	Mesto:integer;
    MinMesto:integer;
  end;

procedure TformHlavni.butnCestaClick(Sender: TObject);
var
	Zacatek,Konec:integer;
  PocetUzlu,i:integer;
  Uzel:array of TTrasa;
  

  procedure PridejUzel(mesto,minmesto:integer);
  begin
  	Inc(PocetUzlu);
    SetLength(Uzel,PocetUzlu);
    Uzel[PocetUzlu-1].mesto:=mesto;
    Uzel[PocetUzlu-1].Minmesto:=minmesto;
  end;

  procedure NajdiOkolni(mesto,minulemesto:integer);
  var
  	i:integer;
  begin
  	for i:=0 to CestyPocet-1 do begin
    	if Cesty[i].Hledano then continue;
      
    end;
  end;
  
begin
	Zacatek:=DejVybrane(cboxOkolni);
  Konec:=DejVybrane(cboxKonec);
	if Zacatek=Konec then begin
  	MessageBox(handle,'Poten a koncov msto je stejn','AutoAtlas',MB_ICONWARNING);
    Exit;
  end;

  MessageBox(handle,'Nedokoneno','AutoAtlas',MB_ICONWARNING);
  Exit;

  for i:=0 to CestyPocet-1 do
  	Cesty[i].Hledano:=false;

  PocetUzlu:=0;
  SetLength(Uzel,0);

  NajdiOkolni(Zacatek,-1);

end;

procedure TformHlavni.mnuiNpoveda1Click(Sender: TObject);
begin
	formNapoveda.ShowModal;
end;

end.
